﻿<?php
/**
 * Author: MDA
 * Author URI: https://github.com/DiUnique
 * Author email: info@md-web.ru
 */

require_once "api/Simpla.php";

class Enot extends Simpla
{
  public function checkout_form($order_id, $button_text = null)
    {
        if (empty($button_text)) {
            $button_text = "Перейти к оплате";
        }

        if ($this->request->method("post") && $this->request->post("go")) {
            $this->redirect($order_id);
        } else {
            $button =
                "<form method='post'>" .
                "<input name='go' type='submit' class='checkout_button' value='" . $button_text . "'>" .
                "</form>";
            return $button;
        }
    }

    public function redirect($order_id)
    {
        $order = $this->orders->get_order((int) $order_id);

        $payment_method = $this->payment->get_payment_method( $order->payment_method_id );
        $payment_settings = $this->payment->get_payment_settings( $payment_method->id );

        // Get options
        $api_url = 'https://api.mivion.com/invoice/create';
        $shop_id = $payment_settings["public_key"];
        $secret_key = $payment_settings["secret_key"];
        $order_id = $order->id;
        $email = $order->email;

        $success_url = $this->config->root_url . "/order/" . $order->url;
        $fail_url = $this->config->root_url . "/order/" . $order->url;

        $amount = $this->money->convert(
            $order->total_price,
            $payment_method->currency_id,
            false
        );
        $amount = number_format($amount, 2, ".", "");

        $args = [
            "shop_id" => $shop_id,
            "order_id" => time() . '_' . $order_id,
            "amount" => $amount,
            "email" => $email,
            "hook_url" => $this->config->root_url ."/payment/Enot/callback.php?o=" . $order->id,
            "success_url" => $success_url,
            "fail_url" => $fail_url,
            "comment" => 'Заказ #' . $order_id,
        ];

        $headers = array('Content-Type: application/json', 'x-api-key:' . $secret_key);

        $response = $this->_sendRequest( $api_url, $args, $headers );

        $response = json_decode($response, true);
        print_r($response);

        if ($response["status"] != 200) {
            print $response["data"]["error"];
        } else {
            print "REDIRECT";
            header("Location: " . $response["data"]["url"]);
        }
        exit();
    }

    public function _sendRequest($action_address, $args, $headers)
    {   
        $args = is_array($args) ? json_encode($args) : $args;

        $ch = curl_init();
        curl_setopt_array($ch, [
            CURLOPT_HTTPHEADER => $headers,
            CURLOPT_VERBOSE => true,
            CURLOPT_SSL_VERIFYHOST => false,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_URL => $action_address,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => $args,
            //                CURLOPT_ENCODING, "gzip",
        ]);

        $response = curl_exec($ch);

        curl_close($ch);

        return $response;
    }

}